package	jp.co.sds_corp.dao.tool;

import java.io.File;

import jp.co.sds_corp.util.config.IConfiguration;

public class SqlInfo
{
	public enum Type {
		SELECT, UPDATE, INSERT, DELETE
	};
	String	id;
	String	sql;
	Type	type;
	Template	template;

	public SqlInfo( IConfiguration config ) throws Exception {
		IConfiguration attr = config.getAttributes();
		id = attr.get( "id" );
		type = Type.valueOf( attr.get( "type" ).toUpperCase() );

		sql = config.get();
	}

	public void setTemplate( Template template ) {
		this.template = template;
	}

	public String getMethod( String dto ) throws Exception {
		String fntemp = template.getDir() + File.separator + type + ".java";

		StringBuffer buf = template.readTemplate( fntemp );
		template.replacePattern( buf, "<$$$ DTO $$$>", dto );
		template.replacePattern( buf, "<$$$ SQL $$$>", sql );
		template.replacePattern( buf, "<$$$ METHOD $$$>", id );
		String ret = buf.toString();
		return ret;
	}

}
