package	jp.co.sds_corp.dao.tool;

import java.util.Iterator;
import java.util.Vector;

import jp.co.sds_corp.util.config.IConfiguration;

public class TableInfo
{
	String	name;
	Vector<ColumnInfo>	vecCol = new Vector<ColumnInfo>();
	Template	template;

	public TableInfo( IConfiguration config ) throws Exception {
		IConfiguration attr = config.getAttributes();
		name = attr.get( "name" );

		IConfiguration c;
		Iterator<IConfiguration> itr;
		itr = config.getChilds( "column" );
		while ( itr.hasNext()) {
			c = itr.next();
			ColumnInfo col = new ColumnInfo( c );
			vecCol.add( col );
// System.out.println( col );
		}
	}

	public void setTemplate( Template template ) {
		this.template = template;
	}

	public String getName() {
		return this.name;
	}

	public String getField() {
		String ret = "";
		for ( int i = 0; i < vecCol.size(); i++ ) {
			ColumnInfo col = vecCol.get( i );
			String desc = null;
			if ( col.getJName() != null && col.getJName().length() > 0 ) {
				desc = "\t/** " + col.getJName() + " */\n";
			}
			if ( col.getDesc() != null && col.getDesc().length() > 0 ) {
				desc = "\t/** " + col.getDesc() + " */\n";
			}
			if ( desc != null ) {
				ret += desc;
			}
			ret += "\t" + col.getJavaType() + "\t" + col.getName() + ";\n";
		}
		return ret;
	}

	public String getMethod() throws Exception {
		StringBuffer bufTemp = template.readTemplate( template.getMethod() );
		String ret = "";
		for ( int i = 0; i < vecCol.size(); i++ ) {
			ColumnInfo col = vecCol.get( i );
			String desc = null;
			if ( col.getDesc() != null ) {
				desc = col.getDesc();
			}
			if ( col.getJName() != null ) {
				desc = col.getJName();
			}
			if ( desc == null ) {
				desc = col.getName();
			}

			StringBuffer temp = new StringBuffer( bufTemp ); 
			template.replacePattern( temp, "<$$$ Name $$$>", col.getName() );
			template.replacePattern( temp, "<$$$ Desc $$$>", desc );
			template.replacePattern( temp, "<$$$ JavaType $$$>", col.getJavaType() );
			template.replacePattern( temp, "<$$$ Method $$$>", col.getMethodName() );
			ret += temp + "\n";
		}
		return ret;
	}

}
